//
// This demo works in x86-64 compatible architecture running linux
// It can be compiled and run with a command:
//
//     gcc demo.c -o demo && ./demo
//

#include <stdio.h>
#include <stdlib.h>
#include <sys/mman.h>

typedef unsigned char uint8;
typedef void (*NativeFunction)();

void arcane(int k)
{
    printf("Arcane magic %i.\n", k);
}

int main()
{
    uint8 *data;
    NativeFunction function;
    unsigned long funcptr;
    int i = 0;

    data = mmap(NULL, 64*4096, PROT_EXEC|PROT_READ|PROT_WRITE, MAP_PRIVATE|MAP_ANONYMOUS, -1, 0);
    if (data == MAP_FAILED)
    {
        printf("mmap failed\n");
    }

    funcptr = (unsigned long)arcane;

    // xor rdi, rdi
    data[i++] = 0x48;
    data[i++] = 0x31;
    data[i++] = 0xFF;

    // mov edi, 24
    data[i++] = 0xBF;
    data[i++] = 24;
    data[i++] = 0;
    data[i++] = 0;
    data[i++] = 0;

    // mov r11, imm64
    data[i++] = 0x49;
    data[i++] = 0xBB;
    data[i++] = funcptr >> 0  & 0xFF;
    data[i++] = funcptr >> 8  & 0xFF;
    data[i++] = funcptr >> 16 & 0xFF;
    data[i++] = funcptr >> 24 & 0xFF;
    data[i++] = funcptr >> 32 & 0xFF;
    data[i++] = funcptr >> 40 & 0xFF;
    data[i++] = funcptr >> 48 & 0xFF;
    data[i++] = funcptr >> 56 & 0xFF;

    // call r11
    data[i++] = 0x41;
    data[i++] = 0xFF;
    data[i++] = 0xD3;

    // ret
    data[i++] = 0xC3;

    // Alternative way to pass the funcptr with relative addressing
    // // call [rip+1]
    // data[i++] = 0xFF;
    // data[i++] = 0x15;
    // data[i++] = 0x01;
    // data[i++] = 0x00;
    // data[i++] = 0x00;
    // data[i++] = 0x00;

    // // ret
    // data[i++] = 0xC3;

    // // funcptr
    // data[i++] = funcptr >> 0  & 0xFF;
    // data[i++] = funcptr >> 8  & 0xFF;
    // data[i++] = funcptr >> 16 & 0xFF;
    // data[i++] = funcptr >> 24 & 0xFF;
    // data[i++] = funcptr >> 32 & 0xFF;
    // data[i++] = funcptr >> 40 & 0xFF;
    // data[i++] = funcptr >> 48 & 0xFF;
    // data[i++] = funcptr >> 56 & 0xFF;


    printf ("ffi gate size %i bytes\n", i);

    function = (NativeFunction)data;
    function();

    return 0;
}
